Index: kernel/generic/src/time/timeout.c
===================================================================
--- kernel/generic/src/time/timeout.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/time/timeout.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,5 @@
 /*
  * Copyright (c) 2001-2004 Jakub Jermar
+ * Copyright (c) 2022 Jiří Zárevúcky
  * All rights reserved.
  *
@@ -57,20 +58,4 @@
 }
 
-/** Reinitialize timeout
- *
- * Initialize all members except the lock.
- *
- * @param timeout Timeout to be initialized.
- *
- */
-void timeout_reinitialize(timeout_t *timeout)
-{
-	timeout->cpu = NULL;
-	timeout->ticks = 0;
-	timeout->handler = NULL;
-	timeout->arg = NULL;
-	link_initialize(&timeout->link);
-}
-
 /** Initialize timeout
  *
@@ -82,6 +67,45 @@
 void timeout_initialize(timeout_t *timeout)
 {
-	irq_spinlock_initialize(&timeout->lock, "timeout_t_lock");
-	timeout_reinitialize(timeout);
+	link_initialize(&timeout->link);
+	timeout->cpu = NULL;
+}
+
+/* Only call when interrupts are disabled. */
+deadline_t timeout_deadline_in_usec(uint32_t usec)
+{
+	if (usec == 0)
+		return 0;
+
+	return CPU_LOCAL->current_clock_tick + us2ticks(usec);
+}
+
+static void timeout_register_deadline_locked(timeout_t *timeout, deadline_t deadline,
+    timeout_handler_t handler, void *arg)
+{
+	assert(!link_in_use(&timeout->link));
+
+	*timeout = (timeout_t) {
+		.cpu = CPU,
+		.deadline = deadline,
+		.handler = handler,
+		.arg = arg,
+		.finished = ATOMIC_VAR_INIT(false),
+	};
+
+	/* Insert timeout into the active timeouts list according to timeout->deadline. */
+
+	link_t *last = list_last(&CPU->timeout_active_list);
+	if (last == NULL || timeout->deadline >= list_get_instance(last, timeout_t, link)->deadline) {
+		list_append(&timeout->link, &CPU->timeout_active_list);
+	} else {
+		for (link_t *cur = list_first(&CPU->timeout_active_list); cur != NULL;
+		    cur = list_next(cur, &CPU->timeout_active_list)) {
+
+			if (timeout->deadline < list_get_instance(cur, timeout_t, link)->deadline) {
+				list_insert_before(&timeout->link, cur);
+				break;
+			}
+		}
+	}
 }
 
@@ -102,58 +126,13 @@
 {
 	irq_spinlock_lock(&CPU->timeoutlock, true);
-	irq_spinlock_lock(&timeout->lock, false);
+	timeout_register_deadline_locked(timeout, timeout_deadline_in_usec(time), handler, arg);
+	irq_spinlock_unlock(&CPU->timeoutlock, true);
+}
 
-	if (timeout->cpu)
-		panic("Unexpected: timeout->cpu != 0.");
-
-	timeout->cpu = CPU;
-	timeout->ticks = us2ticks(time);
-
-	timeout->handler = handler;
-	timeout->arg = arg;
-
-	/*
-	 * Insert timeout into the active timeouts list according to timeout->ticks.
-	 */
-	uint64_t sum = 0;
-	timeout_t *target = NULL;
-	link_t *cur, *prev;
-	prev = NULL;
-	for (cur = list_first(&CPU->timeout_active_list);
-	    cur != NULL; cur = list_next(cur, &CPU->timeout_active_list)) {
-		target = list_get_instance(cur, timeout_t, link);
-		irq_spinlock_lock(&target->lock, false);
-
-		if (timeout->ticks < sum + target->ticks) {
-			irq_spinlock_unlock(&target->lock, false);
-			break;
-		}
-
-		sum += target->ticks;
-		irq_spinlock_unlock(&target->lock, false);
-		prev = cur;
-	}
-
-	if (prev == NULL)
-		list_prepend(&timeout->link, &CPU->timeout_active_list);
-	else
-		list_insert_after(&timeout->link, prev);
-
-	/*
-	 * Adjust timeout->ticks according to ticks
-	 * accumulated in target's predecessors.
-	 */
-	timeout->ticks -= sum;
-
-	/*
-	 * Decrease ticks of timeout's immediate succesor by timeout->ticks.
-	 */
-	if (cur != NULL) {
-		irq_spinlock_lock(&target->lock, false);
-		target->ticks -= timeout->ticks;
-		irq_spinlock_unlock(&target->lock, false);
-	}
-
-	irq_spinlock_unlock(&timeout->lock, false);
+void timeout_register_deadline(timeout_t *timeout, deadline_t deadline,
+    timeout_handler_t handler, void *arg)
+{
+	irq_spinlock_lock(&CPU->timeoutlock, true);
+	timeout_register_deadline_locked(timeout, deadline, handler, arg);
 	irq_spinlock_unlock(&CPU->timeoutlock, true);
 }
@@ -170,40 +149,26 @@
 bool timeout_unregister(timeout_t *timeout)
 {
-	DEADLOCK_PROBE_INIT(p_tolock);
+	if (atomic_load_explicit(&timeout->finished, memory_order_acquire))
+		/* The timeout fired and finished already, no need to check the list. */
+		return false;
 
-grab_locks:
-	irq_spinlock_lock(&timeout->lock, true);
-	if (!timeout->cpu) {
-		irq_spinlock_unlock(&timeout->lock, true);
-		return false;
+	assert(timeout->cpu);
+
+	irq_spinlock_lock(&timeout->cpu->timeoutlock, true);
+
+	bool success = link_in_use(&timeout->link);
+	if (success) {
+		list_remove(&timeout->link);
 	}
 
-	if (!irq_spinlock_trylock(&timeout->cpu->timeoutlock)) {
-		irq_spinlock_unlock(&timeout->lock, true);
-		DEADLOCK_PROBE(p_tolock, DEADLOCK_THRESHOLD);
-		goto grab_locks;
+	irq_spinlock_unlock(&timeout->cpu->timeoutlock, true);
+
+	if (!success) {
+		/* Timeout was fired, we need to wait for the callback to finish. */
+		while (!atomic_load_explicit(&timeout->finished, memory_order_acquire))
+			cpu_spin_hint();
 	}
 
-	/*
-	 * Now we know for sure that timeout hasn't been activated yet
-	 * and is lurking in timeout->cpu->timeout_active_list.
-	 */
-
-	link_t *cur = list_next(&timeout->link,
-	    &timeout->cpu->timeout_active_list);
-	if (cur != NULL) {
-		timeout_t *tmp = list_get_instance(cur, timeout_t, link);
-		irq_spinlock_lock(&tmp->lock, false);
-		tmp->ticks += timeout->ticks;
-		irq_spinlock_unlock(&tmp->lock, false);
-	}
-
-	list_remove(&timeout->link);
-	irq_spinlock_unlock(&timeout->cpu->timeoutlock, false);
-
-	timeout_reinitialize(timeout);
-	irq_spinlock_unlock(&timeout->lock, true);
-
-	return true;
+	return success;
 }
 
Index: kernel/generic/src/udebug/udebug.c
===================================================================
--- kernel/generic/src/udebug/udebug.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/udebug/udebug.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -94,10 +94,5 @@
 static void udebug_wait_for_go(waitq_t *wq)
 {
-	ipl_t ipl = waitq_sleep_prepare(wq);
-
-	wq->missed_wakeups = 0;  /* Enforce blocking. */
-	bool blocked;
-	(void) waitq_sleep_timeout_unsafe(wq, SYNCH_NO_TIMEOUT, SYNCH_FLAGS_NONE, &blocked);
-	waitq_sleep_finish(wq, blocked, ipl);
+	waitq_sleep(wq);
 }
 
@@ -443,8 +438,8 @@
 				/*
 				 * thread's lock must not be held when calling
-				 * waitq_wakeup.
+				 * waitq_close.
 				 *
 				 */
-				waitq_wakeup(&thread->udebug.go_wq, WAKEUP_FIRST);
+				waitq_close(&thread->udebug.go_wq);
 			}
 
Index: kernel/generic/src/udebug/udebug_ops.c
===================================================================
--- kernel/generic/src/udebug/udebug_ops.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/generic/src/udebug/udebug_ops.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -51,5 +51,5 @@
 #include <udebug/udebug.h>
 #include <udebug/udebug_ops.h>
-#include <mem.h>
+#include <memw.h>
 #include <stdlib.h>
 
@@ -83,45 +83,13 @@
 	mutex_lock(&TASK->udebug.lock);
 
-	/* thread_exists() must be called with threads_lock held */
-	irq_spinlock_lock(&threads_lock, true);
-
-	if (!thread_exists(thread)) {
-		irq_spinlock_unlock(&threads_lock, true);
+	thread = thread_try_get(thread);
+
+	if (!thread) {
 		mutex_unlock(&TASK->udebug.lock);
 		return ENOENT;
 	}
-
-	/* thread->lock is enough to ensure the thread's existence */
-	irq_spinlock_exchange(&threads_lock, &thread->lock);
 
 	/* Verify that 'thread' is a userspace thread. */
 	if (!thread->uspace) {
-		/* It's not, deny its existence */
-		irq_spinlock_unlock(&thread->lock, true);
-		mutex_unlock(&TASK->udebug.lock);
-		return ENOENT;
-	}
-
-	/* Verify debugging state. */
-	if (thread->udebug.active != true) {
-		/* Not in debugging session or undesired GO state */
-		irq_spinlock_unlock(&thread->lock, true);
-		mutex_unlock(&TASK->udebug.lock);
-		return ENOENT;
-	}
-
-	/*
-	 * Since the thread has active == true, TASK->udebug.lock
-	 * is enough to ensure its existence and that active remains
-	 * true.
-	 *
-	 */
-	irq_spinlock_unlock(&thread->lock, true);
-
-	/* Only mutex TASK->udebug.lock left. */
-
-	/* Now verify that the thread belongs to the current task. */
-	if (thread->task != TASK) {
-		/* No such thread belonging this task */
 		mutex_unlock(&TASK->udebug.lock);
 		return ENOENT;
@@ -135,4 +103,20 @@
 	mutex_lock(&thread->udebug.lock);
 
+	/* Verify debugging state. */
+	if (thread->udebug.active != true) {
+		/* Not in debugging session or undesired GO state */
+		mutex_unlock(&thread->udebug.lock);
+		mutex_unlock(&TASK->udebug.lock);
+		return ENOENT;
+	}
+
+	/* Now verify that the thread belongs to the current task. */
+	if (thread->task != TASK) {
+		/* No such thread belonging this task */
+		mutex_unlock(&thread->udebug.lock);
+		mutex_unlock(&TASK->udebug.lock);
+		return ENOENT;
+	}
+
 	/* The big task mutex is no longer needed. */
 	mutex_unlock(&TASK->udebug.lock);
@@ -153,4 +137,7 @@
 {
 	mutex_unlock(&thread->udebug.lock);
+
+	/* Drop reference from _thread_op_begin() */
+	thread_put(thread);
 }
 
@@ -281,5 +268,5 @@
 	 *
 	 */
-	waitq_wakeup(&thread->udebug.go_wq, WAKEUP_FIRST);
+	waitq_wake_all(&thread->udebug.go_wq);
 
 	_thread_op_end(thread);
@@ -393,7 +380,5 @@
 	/* FIXME: make sure the thread isn't past debug shutdown... */
 	list_foreach(TASK->threads, th_link, thread_t, thread) {
-		irq_spinlock_lock(&thread->lock, false);
 		bool uspace = thread->uspace;
-		irq_spinlock_unlock(&thread->lock, false);
 
 		/* Not interested in kernel threads. */
Index: kernel/meson.build
===================================================================
--- kernel/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -42,8 +42,4 @@
 subdir('test')
 
-## Cross-platform assembly to start a symtab.data section
-#
-symtab_section = '.section symtab.data, "a", ' + atsign + 'progbits;'
-
 kernel_include_dirs = include_directories(
 	'generic/include',
@@ -52,4 +48,5 @@
 	'..' / 'abi' / 'arch' / KARCH / 'include',
 	'..' / 'abi' / 'include',
+	'..' / 'common' / 'include',
 	'test',
 )
@@ -89,4 +86,7 @@
 	'-T', meson.current_build_dir() / '_link.ld',
 ]
+# The kernel is built as ELF but then copied as a blob of bytes and
+# the permissions are not relevant anyway (needed for binutils 2.39+).
+kernel_link_args += ldflags_ignore_rwx_segments
 
 if CONFIG_LTO
@@ -94,14 +94,29 @@
 endif
 
-if CONFIG_STRIP_BINARIES
-	# TODO: do this after disassembling
-	kernel_link_args += [ '-s' ]
-endif
-
 kernel_c_args = arch_kernel_c_args + kernel_defs + [
 	'-ffreestanding',
-	# TODO: remove this flag
-	cc.get_supported_arguments([ '-Wno-cast-function-type' ]),
+	'-fdebug-prefix-map=../../kernel/=',
+	'-fdebug-prefix-map=../../../kernel/=',
+
+	cc.get_supported_arguments([
+		# TODO: remove this flag
+		'-Wno-cast-function-type',
+
+		# When accessing specific memory addresses that are below
+		# normal page size, the compiler may assume that we actually
+		# dereferenced NULL pointer and warns us about that.
+		# But in kernel we often need to access these addresses
+		# directly hence we need to ignore these warnings.
+		#
+		# TODO: might make more sense to disable this selectively
+		# in specific files (or better yet, for specific lines).
+		'--param=min-pagesize=0',
+	]),
 ]
+
+if not CONFIG_LINE_DEBUG
+	# Keep the debug info needed to get file names for kernel stack traces.
+	kernel_c_args += [ '-gdwarf-5', '-g1', '-gno-statement-frontiers' ]
+endif
 
 if CONFIG_LTO
@@ -133,78 +148,51 @@
 all_kernel_objects = [ instrumentables, noninstrumentables ]
 
-# We iterate the build several times to get symbol table right.
-# Three times is sufficient to get correct even symbols after symtab.
+kernel_name = 'kernel.elf'
+kernel_map_name = kernel_name + '.map'
+kernel_map_path = meson.current_build_dir() / kernel_map_name
+
+kernel_elf = executable(kernel_name,
+	include_directories: kernel_include_dirs,
+	implicit_include_directories: false,
+	c_args: kernel_c_args,
+	link_args: kernel_c_args + kernel_link_args + [
+		'-Wl,-Map,' + kernel_map_path,
+	],
+	link_depends: kernel_ldscript,
+	link_whole: all_kernel_objects,
+	pie: false,
+)
+
+kernel_dbg = custom_target('kernel.dbg',
+	output: 'kernel.dbg',
+	input: kernel_elf,
+	command: [
+		objcopy,
+		'--only-keep-debug',
+		'@INPUT@',
+		'@OUTPUT@',
+	],
+)
+
+kernel_elf_stripped = custom_target(kernel_name + '.stripped',
+	output: kernel_name + '.stripped',
+	input: kernel_elf,
+	command: [
+		objcopy,
+		'--strip-unneeded',
+		'@INPUT@',
+		'@OUTPUT@',
+	],
+)
+
+rd_init_binaries += [[ kernel_elf_stripped, 'boot/kernel.elf' ]]
+install_files += [[ 'boot', kernel_elf_stripped.full_path(), 'kernel.elf' ]]
+install_deps += [ kernel_elf_stripped ]
 
 if CONFIG_SYMTAB
-	# Iterate build three times.
-	iterations = [ 1, 2, 3 ]
-
-	# Generates symbol table information as an object file.
-	genmap = find_program('tools/genmap.py')
-
-	# Symbol table dump needed for genmap.
-	kernel_syms = custom_target('kernel_syms.txt',
-		input: all_kernel_objects,
-		output: 'kernel_syms.txt',
-		command: [ objdump, '-t', '@INPUT@' ],
-		capture: true,
-	)
-else
-	# Build just once.
-	iterations = [ 1 ]
-endif
-
-# Empty symbol map for first iteration.
-kernel_map_S = custom_target('empty_map.S',
-	output: 'empty_map.S',
-	capture: true,
-	command: [ 'echo', kernel_as_prolog + symtab_section ],
-)
-
-foreach iter : iterations
-	is_last = (iter == iterations.length())
-	kernel_name = 'kernel.@0@.elf'.format(iter)
-	kernel_map_name = kernel_name + '.map'
-	kernel_map_path = meson.current_build_dir() / kernel_map_name
-
-	kernel_elf = executable(kernel_name, kernel_map_S,
-		include_directories: kernel_include_dirs,
-		implicit_include_directories: false,
-		c_args: kernel_c_args,
-		link_args: kernel_c_args + kernel_link_args + [
-			'-Wl,-Map,' + kernel_map_path,
-		],
-		link_depends: kernel_ldscript,
-		link_whole: all_kernel_objects,
-		pie: false,
-	)
-
-	# Generate symbol table if this is not the final iteration.
-	if not is_last
-
-		# TODO: Teach kernel to read its own ELF symbol table and get rid of this nonsense.
-		# Need to first make sure all architectures (even future ones with dumb bootloaders) can use ELF formatted kernel.
-
-		kernel_map_bin = custom_target(kernel_map_name + '.bin',
-			output: kernel_map_name + '.bin',
-			input: [ kernel_elf, kernel_syms ],
-			command: [ genmap, kernel_map_path, '@INPUT1@', '@OUTPUT@' ],
-		)
-
-		kernel_map_S_name = kernel_name + '.map.S'
-
-		kernel_map_S = custom_target(kernel_map_S_name,
-			input: kernel_map_bin,
-			output: kernel_map_S_name,
-			capture: true,
-			command: [ 'echo', kernel_as_prolog + symtab_section + ' .incbin "@INPUT@"' ],
-		)
-	endif
-endforeach
-
-rd_init_binaries += [[ kernel_elf, 'boot/kernel.elf' ]]
-
-install_files += [[ 'boot', kernel_elf.full_path(), 'kernel.elf' ]]
-install_deps += [ kernel_elf ]
+	rd_init_binaries += [[ kernel_dbg, 'kernel.dbg' ]]
+	install_files += [[ 'boot', kernel_dbg.full_path(), 'kernel.dbg' ]]
+	install_deps += [ kernel_dbg ]
+endif
 
 kernel_disasm = custom_target('kernel.elf.disasm',
Index: kernel/test/fault/fault1.c
===================================================================
--- kernel/test/fault/fault1.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/test/fault/fault1.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -30,4 +30,6 @@
 #include <test.h>
 
+#pragma GCC diagnostic ignored "-Warray-bounds"
+
 const char *test_fault1(void)
 {
Index: kernel/test/mm/falloc2.c
===================================================================
--- kernel/test/mm/falloc2.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/test/mm/falloc2.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -35,5 +35,5 @@
 #include <atomic.h>
 #include <proc/thread.h>
-#include <mem.h>
+#include <memw.h>
 #include <arch.h>
 
@@ -43,5 +43,4 @@
 #define THREADS      8
 
-static atomic_size_t thread_cnt;
 static atomic_size_t thread_fail;
 
@@ -56,9 +55,6 @@
 		    "Unable to allocate frames\n", THREAD->tid, CPU->id);
 		atomic_inc(&thread_fail);
-		atomic_dec(&thread_cnt);
 		return;
 	}
-
-	thread_detach(THREAD);
 
 	for (unsigned int run = 0; run < THREAD_RUNS; run++) {
@@ -110,11 +106,11 @@
 	TPRINTF("Thread #%" PRIu64 " (cpu%u): Exiting\n",
 	    THREAD->tid, CPU->id);
-	atomic_dec(&thread_cnt);
 }
 
 const char *test_falloc2(void)
 {
-	atomic_store(&thread_cnt, THREADS);
 	atomic_store(&thread_fail, 0);
+
+	thread_t *threads[THREADS] = { };
 
 	for (unsigned int i = 0; i < THREADS; i++) {
@@ -125,11 +121,13 @@
 			break;
 		}
-		thread_ready(thrd);
+		thread_start(thrd);
+		threads[i] = thrd;
 	}
 
-	while (atomic_load(&thread_cnt) > 0) {
-		TPRINTF("Threads left: %zu\n",
-		    atomic_load(&thread_cnt));
-		thread_sleep(1);
+	for (unsigned int i = 0; i < THREADS; i++) {
+		if (threads[i] != NULL)
+			thread_join(threads[i]);
+
+		TPRINTF("Threads left: %u\n", THREADS - i - 1);
 	}
 
Index: kernel/test/mm/slab1.c
===================================================================
--- kernel/test/mm/slab1.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/test/mm/slab1.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -31,5 +31,5 @@
 #include <proc/thread.h>
 #include <arch.h>
-#include <mem.h>
+#include <memw.h>
 
 #define VAL_COUNT  1024
@@ -121,5 +121,4 @@
 static void *thr_data[THREADS][THR_MEM_COUNT];
 static slab_cache_t *thr_cache;
-static semaphore_t thr_sem;
 
 static void slabtest(void *data)
@@ -127,6 +126,4 @@
 	int offs = (int) (sysarg_t) data;
 	int i, j;
-
-	thread_detach(THREAD);
 
 	TPRINTF("Starting thread #%" PRIu64 "...\n", THREAD->tid);
@@ -144,26 +141,27 @@
 
 	TPRINTF("Thread #%" PRIu64 " finished\n", THREAD->tid);
-
-	semaphore_up(&thr_sem);
 }
 
 static void testthreads(void)
 {
-	thread_t *t;
-	int i;
-
 	thr_cache = slab_cache_create("thread_cache", THR_MEM_SIZE, 0, NULL, NULL,
 	    SLAB_CACHE_NOMAGAZINE);
 
-	semaphore_initialize(&thr_sem, 0);
-	for (i = 0; i < THREADS; i++) {
-		if (!(t = thread_create(slabtest, (void *) (sysarg_t) i, TASK, THREAD_FLAG_NONE, "slabtest"))) {
+	thread_t *threads[THREADS] = { };
+
+	for (int i = 0; i < THREADS; i++) {
+		threads[i] = thread_create(slabtest, (void *) (sysarg_t) i,
+		    TASK, THREAD_FLAG_NONE, "slabtest");
+		if (threads[i]) {
+			thread_start(threads[i]);
+		} else {
 			TPRINTF("Could not create thread %d\n", i);
-		} else
-			thread_ready(t);
+		}
 	}
 
-	for (i = 0; i < THREADS; i++)
-		semaphore_down(&thr_sem);
+	for (int i = 0; i < THREADS; i++) {
+		if (threads[i] != NULL)
+			thread_join(threads[i]);
+	}
 
 	slab_cache_destroy(thr_cache);
Index: kernel/test/mm/slab2.c
===================================================================
--- kernel/test/mm/slab2.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/test/mm/slab2.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -32,5 +32,5 @@
 #include <arch.h>
 #include <mm/frame.h>
-#include <mem.h>
+#include <memw.h>
 #include <synch/condvar.h>
 #include <synch/mutex.h>
@@ -127,5 +127,4 @@
 
 static slab_cache_t *thr_cache;
-static semaphore_t thr_sem;
 static condvar_t thread_starter;
 static mutex_t starter_mutex;
@@ -136,6 +135,4 @@
 {
 	void *data = NULL, *new;
-
-	thread_detach(THREAD);
 
 	mutex_lock(&starter_mutex);
@@ -190,6 +187,4 @@
 	if (!test_quiet)
 		slab_print_list();
-
-	semaphore_up(&thr_sem);
 }
 
@@ -200,6 +195,4 @@
 	 * then release everything, then again allocate, then release
 	 */
-	thread_t *t;
-	int i;
 
 	TPRINTF("Running stress test with size %d\n", size);
@@ -209,16 +202,24 @@
 
 	thr_cache = slab_cache_create("thread_cache", size, 0, NULL, NULL, 0);
-	semaphore_initialize(&thr_sem, 0);
-	for (i = 0; i < THREADS; i++) {
-		if (!(t = thread_create(slabtest, NULL, TASK, THREAD_FLAG_NONE, "slabtest"))) {
+
+	thread_t *threads[THREADS] = { };
+
+	for (int i = 0; i < THREADS; i++) {
+		threads[i] = thread_create(slabtest, NULL,
+		    TASK, THREAD_FLAG_NONE, "slabtest");
+		if (threads[i]) {
+			thread_start(threads[i]);
+		} else {
 			TPRINTF("Could not create thread %d\n", i);
-		} else
-			thread_ready(t);
-	}
+		}
+	}
+
 	thread_sleep(1);
 	condvar_broadcast(&thread_starter);
 
-	for (i = 0; i < THREADS; i++)
-		semaphore_down(&thr_sem);
+	for (int i = 0; i < THREADS; i++) {
+		if (threads[i] != NULL)
+			thread_join(threads[i]);
+	}
 
 	slab_cache_destroy(thr_cache);
Index: kernel/test/synch/semaphore1.c
===================================================================
--- kernel/test/synch/semaphore1.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/test/synch/semaphore1.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -46,6 +46,4 @@
 static void producer(void *arg)
 {
-	thread_detach(THREAD);
-
 	waitq_sleep(&can_start);
 
@@ -58,6 +56,4 @@
 static void consumer(void *arg)
 {
-	thread_detach(THREAD);
-
 	waitq_sleep(&can_start);
 
@@ -93,16 +89,20 @@
 				thrd = thread_create(consumer, NULL, TASK,
 				    THREAD_FLAG_NONE, "consumer");
-				if (thrd)
-					thread_ready(thrd);
-				else
+				if (thrd) {
+					thread_start(thrd);
+					thread_detach(thrd);
+				} else {
 					TPRINTF("could not create consumer %d\n", i);
+				}
 			}
 			for (k = 0; k < (4 - i); k++) {
 				thrd = thread_create(producer, NULL, TASK,
 				    THREAD_FLAG_NONE, "producer");
-				if (thrd)
-					thread_ready(thrd);
-				else
+				if (thrd) {
+					thread_start(thrd);
+					thread_detach(thrd);
+				} else {
 					TPRINTF("could not create producer %d\n", i);
+				}
 			}
 		}
@@ -111,5 +111,5 @@
 
 		thread_sleep(1);
-		waitq_wakeup(&can_start, WAKEUP_ALL);
+		waitq_wake_all(&can_start);
 
 		while ((items_consumed != consumers) || (items_produced != producers)) {
Index: kernel/test/synch/semaphore2.c
===================================================================
--- kernel/test/synch/semaphore2.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/test/synch/semaphore2.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -61,6 +61,4 @@
 	int to;
 
-	thread_detach(THREAD);
-
 	waitq_sleep(&can_start);
 
@@ -94,12 +92,14 @@
 		thrd = thread_create(consumer, NULL, TASK,
 		    THREAD_FLAG_NONE, "consumer");
-		if (thrd)
-			thread_ready(thrd);
-		else
+		if (thrd) {
+			thread_start(thrd);
+			thread_detach(thrd);
+		} else {
 			TPRINTF("Error creating thread\n");
+		}
 	}
 
 	thread_usleep(20000);
-	waitq_wakeup(&can_start, WAKEUP_ALL);
+	waitq_wake_all(&can_start);
 
 	return NULL;
Index: kernel/test/thread/thread1.c
===================================================================
--- kernel/test/thread/thread1.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ kernel/test/thread/thread1.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -38,34 +38,29 @@
 
 static atomic_bool finish;
-static atomic_size_t threads_finished;
 
 static void threadtest(void *data)
 {
-	thread_detach(THREAD);
-
 	while (atomic_load(&finish)) {
 		TPRINTF("%" PRIu64 " ", THREAD->tid);
 		thread_usleep(100000);
 	}
-	atomic_inc(&threads_finished);
 }
 
 const char *test_thread1(void)
 {
-	unsigned int i;
-	size_t total = 0;
+	atomic_store(&finish, true);
 
-	atomic_store(&finish, true);
-	atomic_store(&threads_finished, 0);
+	thread_t *threads[THREADS] = { };
 
-	for (i = 0; i < THREADS; i++) {
-		thread_t *t;
-		if (!(t = thread_create(threadtest, NULL, TASK,
-		    THREAD_FLAG_NONE, "threadtest"))) {
+	for (int i = 0; i < THREADS; i++) {
+		threads[i] = thread_create(threadtest, NULL,
+		    TASK, THREAD_FLAG_NONE, "threadtest");
+
+		if (threads[i]) {
+			thread_start(threads[i]);
+		} else {
 			TPRINTF("Could not create thread %d\n", i);
 			break;
 		}
-		thread_ready(t);
-		total++;
 	}
 
@@ -74,7 +69,10 @@
 
 	atomic_store(&finish, false);
-	while (atomic_load(&threads_finished) < total) {
-		TPRINTF("Threads left: %zu\n", total - atomic_load(&threads_finished));
-		thread_sleep(1);
+
+	for (int i = 0; i < THREADS; i++) {
+		if (threads[i] != NULL)
+			thread_join(threads[i]);
+
+		TPRINTF("Threads left: %d\n", THREADS - i - 1);
 	}
 
Index: meson.build
===================================================================
--- meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -36,5 +36,5 @@
     [ 'c', 'cpp' ],
     default_options : ['buildtype=plain', 'c_std=gnu11', 'cpp_std=c++17', 'warning_level=2', 'werror=false', 'b_staticpic=false', 'prefix=/' ],
-    meson_version: '>=0.50.1',
+    meson_version: '>=0.55.0',
 )
 
@@ -61,7 +61,4 @@
 
 ## Some architectures need a particular string at the beginning of assembly files.
-if not is_variable('kernel_as_prolog')
-	kernel_as_prolog = ''
-endif
 if not is_variable('uspace_as_prolog')
 	uspace_as_prolog = ''
@@ -75,4 +72,12 @@
 install_files = []
 install_deps = []
+
+# Exported libraries and include files
+# Format: [ type, source_file, destination ]
+# See meson/part/exports/copy-export.sh for supported file types.
+exported_devel_files = [
+    [ 'includenamedsymlink', 'libc', 'common' ]
+]
+
 # Install script for headers.
 # TODO: Make a list of directories and turn into script later.
Index: meson/arch/amd64/meson.build
===================================================================
--- meson/arch/amd64/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ meson/arch/amd64/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,3 +1,4 @@
 #
+# Copyright (c) 2021 Jiri Svoboda
 # Copyright (c) 2019 Jiří Zárevúcky
 # All rights reserved.
@@ -44,10 +45,8 @@
 endif
 
-
-# TODO: Enable --gc-sections
-arch_kernel_link_args = [ '-Wl,-z,max-page-size=0x1000', '-nostdlib', '-Wl,--no-gc-sections' ]
+arch_kernel_link_args = [ '-Wl,-z,max-page-size=0x1000', '-nostdlib' ]
 arch_uspace_link_args = [ '-Wl,-z,max-page-size=0x1000', '-nostdlib', '-lgcc' ]
 
-
+# Binaries to be included in a barebone build
 rd_essential += [
 	'app/edit',
@@ -56,9 +55,12 @@
 
 	'srv/audio/hound',
+]
 
+# Drivers to be included in a barebone build
+rd_essential_drv += [
 	'drv/intctl/apic',
 	'drv/intctl/i8259',
 	'drv/platform/pc',
-	'drv/block/ata_bd',
+	'drv/block/isa-ide',
 	'drv/bus/pci/pciintel',
 	'drv/bus/isa',
@@ -68,2 +70,40 @@
 	'drv/hid/xtkbd',
 ]
+
+# Drivers to be included in a regular build
+rd_drv += [
+	'drv/audio/hdaudio',
+	'drv/audio/sb16',
+	'drv/block/ahci',
+	'drv/block/isa-ide',
+	'drv/block/pci-ide',
+	'drv/block/usbmast',
+	'drv/block/virtio-blk',
+	'drv/bus/isa',
+	'drv/bus/pci/pciintel',
+	'drv/bus/usb/ehci',
+	'drv/bus/usb/ohci',
+	'drv/bus/usb/uhci',
+	'drv/bus/usb/usbdiag',
+	'drv/bus/usb/usbflbk',
+	'drv/bus/usb/usbhub',
+	'drv/bus/usb/usbmid',
+	'drv/bus/usb/vhc',
+	'drv/bus/usb/xhci',
+	'drv/char/i8042',
+	'drv/char/ns8250',
+	'drv/char/pc-lpt',
+	'drv/hid/ps2mouse',
+	'drv/hid/xtkbd',
+	'drv/hid/usbhid',
+	'drv/intctl/apic',
+	'drv/intctl/i8259',
+	'drv/nic/ar9271',
+	'drv/nic/e1k',
+	'drv/nic/ne2k',
+	'drv/nic/rtl8139',
+	'drv/nic/rtl8169',
+	'drv/nic/virtio-net',
+	'drv/platform/pc',
+	'drv/time/cmos-rtc',
+]
Index: meson/arch/arm32/meson.build
===================================================================
--- meson/arch/arm32/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ meson/arch/arm32/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,3 +1,4 @@
 #
+# Copyright (c) 2021 Jiri Svoboda
 # Copyright (c) 2019 Jiří Zárevúcky
 # All rights reserved.
@@ -41,12 +42,14 @@
 ]
 
+arch_kernel_c_args = arch_uspace_c_args + [ '-mno-unaligned-access', '-mfpu=vfpv3' ]
+arch_kernel_c_args += cc.get_supported_arguments(['-mgeneral-regs-only' ])
+arch_kernel_link_args = [ '-nostdlib', '-Wl,-z,max-page-size=0x1000' ]
+
 if CONFIG_FPU
-	# This is necessary for kernel too, to allow vmsr insn and fpexc manipulation.
-	# Use vfp32 to allow context save/restore of d16-d31 regs.
-	arch_uspace_c_args += [ '-mfloat-abi=hard' ]
+    # Need to use softfp because our libgcc.a uses it too
+    # softfp - generate code with soft-float calling conventions but allow use
+    # of "hard" float instructions
+    arch_uspace_c_args += [ '-mfloat-abi=softfp' ]
 endif
-
-arch_kernel_c_args = arch_uspace_c_args + [ '-mno-unaligned-access', '-mfpu=vfpv3' ]
-arch_kernel_link_args = [ '-nostdlib', '-Wl,-z,max-page-size=0x1000' ]
 arch_uspace_link_args = [ '-nostdlib', '-lgcc', '-Wl,-z,max-page-size=0x1000' ]
 
@@ -54,6 +57,5 @@
 arch_boot_link_args = arch_kernel_link_args
 
-
-rd_essential += [
+rd_essential_drv += [
 	'drv/bus/usb/ehci',
 	'drv/bus/usb/ohci',
@@ -73,5 +75,5 @@
 
 elif MACHINE == 'beagleboardxm' or MACHINE == 'beaglebone'
-	rd_essential += [
+	rd_essential_drv += [
 		'drv/platform/amdm37x',
 		'drv/fb/amdm37x_dispc',
@@ -79,5 +81,5 @@
 
 elif MACHINE == 'integratorcp'
-	rd_essential += [
+	rd_essential_drv += [
 		'drv/char/pl050',
 		'drv/hid/atkbd',
@@ -87,2 +89,4 @@
 	]
 endif
+
+rd_drv += rd_essential_drv
Index: meson/arch/arm64/meson.build
===================================================================
--- meson/arch/arm64/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ meson/arch/arm64/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,3 +1,4 @@
 #
+# Copyright (c) 2021 Jiri Svoboda
 # Copyright (c) 2015 Petr Pavlu
 # All rights reserved.
@@ -27,5 +28,9 @@
 #
 
-arch_uspace_c_args = [ '-D__LE__', '-fno-omit-frame-pointer' ]
+arch_uspace_c_args = [
+	'-D__LE__',
+	'-fno-omit-frame-pointer',
+	cc.get_supported_arguments(['-mno-outline-atomics']),
+]
 arch_kernel_c_args = arch_uspace_c_args + [ '-march=armv8-a+nofp+nosimd', '-mgeneral-regs-only' ]
 arch_kernel_link_args = [ '-nostdlib' ]
@@ -42,9 +47,9 @@
 # processor is in the execution mode that has unaligned access enabled. The
 # -mstrict-align option is therefore not needed.
-arch_boot_c_args = arch_uspace_c_args + [ '-fpic', '-fvisibility=hidden', '-fno-function-sections' ]
-arch_boot_link_args = [ '-Wl,-shared', '-Wl,--no-gc-sections' ]
+arch_boot_c_args = arch_uspace_c_args + [ '-fpic', '-fvisibility=hidden' ]
+arch_boot_link_args = [ '-Wl,-shared' ] + ldflags_ignore_rwx_segments
 
 if MACHINE == 'virt'
-	rd_essential += [
+	rd_essential_drv += [
 		'drv/char/pl011',
 		'drv/intctl/gicv2',
@@ -54,5 +59,5 @@
 
 if MACHINE == 'hikey960'
-	rd_essential += [
+	rd_essential_drv += [
 		'drv/char/pl011',
 		'drv/intctl/gicv2',
@@ -60,2 +65,4 @@
 	]
 endif
+
+rd_drv += rd_essential_drv
